diff --git a/src/main/java/net/minecraft/core/block/BlockJar.java b/game/core/src/main/java/net/minecraft/core/block/BlockJar.java
similarity index 83%
rename from src/main/java/net/minecraft/core/block/BlockJar.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockJar.java
index 0c33182d7..28d2458f9 100644
--- a/src/main/java/net/minecraft/core/block/BlockJar.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockJar.java
@@ -40,27 +40,11 @@ public class BlockJar extends BlockTileEntity {
     }
 
     @Override
-    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
-        float offset = 0.0F;
-        return AABB.getTemporaryBB(x + 0.3125f, y + offset, z + 0.3125f, x + 1 - 0.3125f, (float) y + 0.375f + offset, z + 1 - 0.3125f);
-    }
-    @Override
-    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        return getCollisionBoundingBoxFromPool(world, x, y, z);
-    }
-    @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
-    {
-        AABB aabb = getCollisionBoundingBoxFromPool(world, x, y, z);
-        minX = aabb.minX - x;
-        minY = aabb.minY - y;
-        minZ = aabb.minZ - z;
-        maxX = aabb.maxX - x;
-        maxY = aabb.maxY - y;
-        maxZ = aabb.maxZ - z;
+        return AABB.getTemporaryBB(0.3125f, 0, 0.3125f, 1 - 0.3125f, 0.375f, 1 - 0.3125f);
     }
+
     @Override
     public boolean isCubeShaped()
     {
@@ -100,15 +84,14 @@ public class BlockJar extends BlockTileEntity {
                     tileEntity.flowerData = player.getHeldItem().getMetadata();
                     world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, this, EnumBlockSoundEffectType.PLACE);
                     return true;
-                } else if (blockInHand instanceof BlockFlowerStackable && blockInHand == Block.getBlock(tileEntity.flowerInPot)) {
+                } else if (blockInHand instanceof BlockFlowerStackable && blockInHand == Blocks.getBlock(tileEntity.flowerInPot)) {
                     final int metadata = tileEntity.flowerData;
                     final int currentStackCount = BlockFlowerStackable.getStackCount(metadata);
                     if (currentStackCount >= BlockFlowerStackable.MAX_STACK_COUNT) {
                         return false;
                     }
 
-                    final int newMetadata = BlockFlowerStackable.setPermanent(BlockFlowerStackable.setStackCount(metadata, currentStackCount + 1), true);
-                    tileEntity.flowerData = newMetadata;
+                    tileEntity.flowerData = BlockFlowerStackable.setPermanent(BlockFlowerStackable.setStackCount(metadata, currentStackCount + 1), true);
                     world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, this, EnumBlockSoundEffectType.PLACE);
                     player.getHeldItem().consumeItem(player);
                     return true;
diff --git a/src/main/java/net/minecraft/core/block/BlockLadder.java b/game/core/src/main/java/net/minecraft/core/block/BlockLadder.java
similarity index 75%
rename from src/main/java/net/minecraft/core/block/BlockLadder.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLadder.java
index e9da8c4f9..b477fd781 100644
--- a/src/main/java/net/minecraft/core/block/BlockLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLadder.java
@@ -29,22 +29,22 @@ public class BlockLadder extends Block {
 	}
 	
 	@Override
-	public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z) {
-		setBlockBounds(world.getBlockMetadata(x, y, z));
-	}
-	
-	@Override
-	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
-		setBlockBounds(world.getBlockMetadata(x, y, z));
-		return super.getCollisionBoundingBoxFromPool(world, x, y, z);
-	}
-	
-	@Override
-	public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
-		setBlockBounds(world.getBlockMetadata(x, y, z));
-		return super.getSelectedBoundingBoxFromPool(world, x, y, z);
+	public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z) {
+		Side side = getSideFromMeta(world.getBlockMetadata(x, y, z));
+
+		float width = 3.0f / 16.0f;
+
+		if(side == Side.SOUTH) {
+			return AABB.getTemporaryBB(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, width);
+		}else if(side == Side.WEST) {
+			return AABB.getTemporaryBB(1.0f - width, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
+		}else if(side == Side.EAST) {
+			return AABB.getTemporaryBB(0.0f, 0.0f, 0.0f, width, 1.0f, 1.0f);
+		}else {
+			return AABB.getTemporaryBB(0.0f, 0.0f, 1.0f - width, 1.0f, 1.0f, 1.0f);
+		}
 	}
-	
+
 	@Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
 		if(!canExistAt(world, x, y, z, world.getBlockMetadata(x, y, z))) {
@@ -90,23 +90,7 @@ public class BlockLadder extends Block {
 		
 		return world.isBlockNormalCube(x, y, z);
 	}
-	
-	public void setBlockBounds(int meta) {
-		Side side = getSideFromMeta(meta);
-		
-		float width = 3.0f / 16.0f;
-		
-		if(side == Side.SOUTH) {
-			setBlockBounds(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, width);
-		}else if(side == Side.WEST) {
-			setBlockBounds(1.0f - width, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
-		}else if(side == Side.EAST) {
-			setBlockBounds(0.0f, 0.0f, 0.0f, width, 1.0f, 1.0f);
-		}else {
-			setBlockBounds(0.0f, 0.0f, 1.0f - width, 1.0f, 1.0f, 1.0f);
-		}
-	}
-	
+
 	/**
 	 * Returns the side of the block the ladder is attached to
 	 */
diff --git a/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java b/game/core/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
similarity index 88%
rename from src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
index 553e2f079..a68da71e2 100644
--- a/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLanternFirefly.java
@@ -31,31 +31,13 @@ public class BlockLanternFirefly extends Block{
     }
 
     @Override
-    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
         int metadata = world.getBlockMetadata(x, y, z);
         float offset = 0.0F;
         if ((metadata & MASK_HANGING) != 0)
             offset = 0.3875F;
-        return AABB.getTemporaryBB(x + 0.3125f, y + offset, z + 0.3125f, x + 1 - 0.3125f, (float) y + 0.5F + offset, z + 1 - 0.3125f);
-    }
-
-    @Override
-    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        return getCollisionBoundingBoxFromPool(world, x, y, z);
-    }
-
-    @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
-    {
-        AABB aabb = getCollisionBoundingBoxFromPool(world, x, y, z);
-        minX = aabb.minX - x;
-        minY = aabb.minY - y;
-        minZ = aabb.minZ - z;
-        maxX = aabb.maxX - x;
-        maxY = aabb.maxY - y;
-        maxZ = aabb.maxZ - z;
+        return AABB.getTemporaryBB(0.3125f, offset,  0.3125f, 1 - 0.3125f, 0.5F + offset, 1 - 0.3125f);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockLayerBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLayerBase.java
similarity index 69%
rename from src/main/java/net/minecraft/core/block/BlockLayerBase.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLayerBase.java
index 8c986ae15..f6125a815 100644
--- a/src/main/java/net/minecraft/core/block/BlockLayerBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLayerBase.java
@@ -22,13 +22,6 @@ public abstract class BlockLayerBase extends Block
     	this.idSupplier = idSupplier;
     	return this;
     }
-    @Override
-	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        int l = world.getBlockMetadata(x, y, z) & 7;
-        float f = (float)(2 * (1 + l)) / 16F;
-        return AABB.getTemporaryBB((double) x + minX, (double) y + minY, (double) z + minZ, (double) x + maxX, (float) y + f, (double) z + maxZ);
-    }
 
     @Override
 	public boolean isSolidRender()
@@ -43,11 +36,11 @@ public abstract class BlockLayerBase extends Block
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z) & 7;
         float f = (float)(2 * (1 + l)) / 16F;
-        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, f, 1.0F);
+        return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, f, 1.0F);
     }
     public int getFullBlockID() {
         return idSupplier.get();
diff --git a/src/main/java/net/minecraft/core/block/BlockLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/block/BlockLayerLeaves.java
similarity index 97%
rename from src/main/java/net/minecraft/core/block/BlockLayerLeaves.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLayerLeaves.java
index 1dacf8349..d28f0f521 100644
--- a/src/main/java/net/minecraft/core/block/BlockLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLayerLeaves.java
@@ -49,7 +49,7 @@ public class BlockLayerLeaves extends BlockLayerBase
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
         int l = world.getBlockId(x, y - 1, z);
-        if(l == 0 || (!Block.blocksList[l].isSolidRender() && !(Block.blocksList[l] instanceof BlockLeavesBase)))
+        if(l == 0 || (!Blocks.blocksList[l].isSolidRender() && !(Blocks.blocksList[l] instanceof BlockLeavesBase)))
         {
         	return false;
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockLayerSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLayerSnow.java
similarity index 86%
rename from src/main/java/net/minecraft/core/block/BlockLayerSnow.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLayerSnow.java
index 585600eae..b96913312 100644
--- a/src/main/java/net/minecraft/core/block/BlockLayerSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLayerSnow.java
@@ -7,8 +7,6 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
@@ -22,14 +20,6 @@ public class BlockLayerSnow extends BlockLayerBase
         setTicking(true);
     }
 
-    @Override
-    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        int l = world.getBlockMetadata(x, y, z) & 7;
-        float f = (float)(2 * (1 + l)) / 16F;
-        return AABB.getTemporaryBB((double) x + minX, (double) y + minY, (double) z + minZ, (double) x + maxX, (float) y + f - 0.125F, (double) z + maxZ);
-    }
-
     public void accumulate(World world, int x, int y, int z)
     {
     	int myMetadata = world.getBlockMetadata(x, y, z);
@@ -52,7 +42,7 @@ public class BlockLayerSnow extends BlockLayerBase
 	public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
         int l = world.getBlockId(x, y - 1, z);
-        if(l == 0 || (!Block.blocksList[l].isSolidRender() && !(Block.blocksList[l] instanceof BlockLeavesBase)))
+        if(l == 0 || (!Blocks.blocksList[l].isSolidRender() && !(Blocks.blocksList[l] instanceof BlockLeavesBase)))
         {
         	return false;
         }
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
similarity index 97%
rename from src/main/java/net/minecraft/core/block/BlockLeavesBase.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
index a0a1277fe..6fc2ba75e 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLeavesBase.java
@@ -68,7 +68,7 @@ public abstract class BlockLeavesBase extends Block
                     for(int dz = -radius; dz <= radius; dz++)
                     {
                         int blockId = world.getBlockId(x + dx, y + dy, z + dz);
-                        if(Block.blocksList[blockId] instanceof BlockLeavesBase)
+                        if(Blocks.blocksList[blockId] instanceof BlockLeavesBase)
                         {
                             int meta = world.getBlockMetadata(x + dx, y + dy, z + dz);
                             if (!isPermanent(meta))
@@ -109,12 +109,12 @@ public abstract class BlockLeavesBase extends Block
                         for(int zOffset = -byte0; zOffset <= byte0; zOffset++)
                         {
                             int k3 = world.getBlockId(x + xOffset, y + yOffset, z + zOffset);
-                            if(Block.blocksList[k3] instanceof BlockLog)
+                            if(Blocks.blocksList[k3] instanceof BlockLog)
                             {
                                 adjacentTreeBlocks[(xOffset + halfLength) * xSpan + (yOffset + halfLength) * ySpan + (zOffset + halfLength)] = 0;
                                 continue;
                             }
-                            if(Block.blocksList[k3] instanceof BlockLeavesBase)
+                            if(Blocks.blocksList[k3] instanceof BlockLeavesBase)
                             {
                                 adjacentTreeBlocks[(xOffset + halfLength) * xSpan + (yOffset + halfLength) * ySpan + (zOffset + halfLength)] = -2;
                             } else
diff --git a/src/main/java/net/minecraft/core/block/BlockLeavesOak.java b/game/core/src/main/java/net/minecraft/core/block/BlockLeavesOak.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/BlockLeavesOak.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLeavesOak.java
index 5426f8027..e446d3bdd 100644
--- a/src/main/java/net/minecraft/core/block/BlockLeavesOak.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLeavesOak.java
@@ -23,7 +23,7 @@ public class BlockLeavesOak extends BlockLeavesBase
             {
                 int id = world.getBlockId(x, y + q, z);
                 if (id != 0) break;
-                if (Blocks.LAYER_LEAVES_OAK.canPlaceBlockAt(world, x, y + q, z) && Block.blocksList[world.getBlockId(x, y + q - 1, z)].blockMaterial.blocksMotion())
+                if (Blocks.LAYER_LEAVES_OAK.canPlaceBlockAt(world, x, y + q, z) && Blocks.blocksList[world.getBlockId(x, y + q - 1, z)].blockMaterial.blocksMotion())
                 {
                     world.setBlockWithNotify(x, y + q, z, Blocks.LAYER_LEAVES_OAK.id);
                     break;
diff --git a/src/main/java/net/minecraft/core/block/BlockLever.java b/game/core/src/main/java/net/minecraft/core/block/BlockLever.java
similarity index 94%
rename from src/main/java/net/minecraft/core/block/BlockLever.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLever.java
index 7023bdab9..dd455cbb6 100644
--- a/src/main/java/net/minecraft/core/block/BlockLever.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLever.java
@@ -194,7 +194,7 @@ public class BlockLever extends Block
                     shouldBreak = !world.canPlaceOnSurfaceOfBlock(x, y + 1, z);
                     break;
                 default:
-                    shouldBreak = true;
+                    shouldBreak = false;
             }
             if(shouldBreak)
             {
@@ -218,24 +218,24 @@ public class BlockLever extends Block
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
         int rotation = getRotation(world.getBlockMetadata(x, y, z));
         float f = 0.1875F;
         if(rotation == ROTATION_EAST) {
-            setBlockBounds(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
+            return AABB.getTemporaryBB(0.0F, 0.2F, 0.5F - f, f * 2.0F, 0.8F, 0.5F + f);
         } else if(rotation == ROTATION_WEST) {
-            setBlockBounds(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
+            return AABB.getTemporaryBB(1.0F - f * 2.0F, 0.2F, 0.5F - f, 1.0F, 0.8F, 0.5F + f);
         } else if(rotation == ROTATION_SOUTH) {
-            setBlockBounds(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
+            return AABB.getTemporaryBB(0.5F - f, 0.2F, 0.0F, 0.5F + f, 0.8F, f * 2.0F);
         } else if(rotation == ROTATION_NORTH) {
-            setBlockBounds(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
+            return AABB.getTemporaryBB(0.5F - f, 0.2F, 1.0F - f * 2.0F, 0.5F + f, 0.8F, 1.0F);
         } else if (rotation == ROTATION_TOP_NS || rotation == ROTATION_TOP_WE) {
             float f1 = 0.25F;
-            setBlockBounds(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
+            return AABB.getTemporaryBB(0.5F - f1, 0.0F, 0.5F - f1, 0.5F + f1, 0.6F, 0.5F + f1);
         } else {
             float f1 = 0.25F;
-            setBlockBounds(0.5F - f1, 0.4, 0.5F - f1, 0.5F + f1, 1F, 0.5F + f1);
+            return AABB.getTemporaryBB(0.5F - f1, 0.4, 0.5F - f1, 0.5F + f1, 1F, 0.5F + f1);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/block/BlockLog.java b/game/core/src/main/java/net/minecraft/core/block/BlockLog.java
similarity index 94%
rename from src/main/java/net/minecraft/core/block/BlockLog.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockLog.java
index 9d81135a2..02df9bd44 100644
--- a/src/main/java/net/minecraft/core/block/BlockLog.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLog.java
@@ -25,7 +25,7 @@ public class BlockLog extends BlockAxisAligned
                     for(int _z = -r; _z <= r; _z++)
                     {
                         int l1 = world.getBlockId(x + _x, y + _y, z + _z);
-                        if(!(Block.blocksList[l1] instanceof BlockLeavesBase))
+                        if(!(Blocks.blocksList[l1] instanceof BlockLeavesBase))
                         {
                             continue;
                         }
diff --git a/src/main/java/net/minecraft/core/block/BlockMoss.java b/game/core/src/main/java/net/minecraft/core/block/BlockMoss.java
similarity index 98%
rename from src/main/java/net/minecraft/core/block/BlockMoss.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockMoss.java
index 0026243d9..86fc4ab67 100644
--- a/src/main/java/net/minecraft/core/block/BlockMoss.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockMoss.java
@@ -76,7 +76,7 @@ public class BlockMoss extends Block implements IBonemealable {
 	public static Block getMossBlock(int blockId) {
 		if (blockId == 0)
 			return null;
-		return getMossBlock(Block.blocksList[blockId]);
+		return getMossBlock(Blocks.blocksList[blockId]);
 	}
 
 	public static Block getMossBlock(Block stoneBlock) {
@@ -86,7 +86,7 @@ public class BlockMoss extends Block implements IBonemealable {
 	public static Block getStoneBlock(int blockId) {
 		if (blockId == 0)
 			return null;
-		return getStoneBlock(Block.blocksList[blockId]);
+		return getStoneBlock(Blocks.blocksList[blockId]);
 	}
 	
 	public static Block getStoneBlock(Block mossBlock) {
diff --git a/src/main/java/net/minecraft/core/block/BlockMushroom.java b/game/core/src/main/java/net/minecraft/core/block/BlockMushroom.java
similarity index 97%
rename from src/main/java/net/minecraft/core/block/BlockMushroom.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockMushroom.java
index 9d7383156..4b2bb9d9d 100644
--- a/src/main/java/net/minecraft/core/block/BlockMushroom.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockMushroom.java
@@ -38,7 +38,7 @@ public class BlockMushroom extends BlockFlower
     @Override
 	protected boolean mayPlaceOn(int blockId)
     {
-        return Block.solid[blockId];
+        return Blocks.solid[blockId];
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockOverlayPebbles.java b/game/core/src/main/java/net/minecraft/core/block/BlockOverlayPebbles.java
similarity index 82%
rename from src/main/java/net/minecraft/core/block/BlockOverlayPebbles.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockOverlayPebbles.java
index 5082e303c..2442aa9e5 100644
--- a/src/main/java/net/minecraft/core/block/BlockOverlayPebbles.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockOverlayPebbles.java
@@ -14,6 +14,7 @@ public class BlockOverlayPebbles extends Block
     public BlockOverlayPebbles(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
+        setBlockBounds(0, 0, 0, 1, 0.0625F, 1);
     }
 
     @Override
@@ -41,12 +42,6 @@ public class BlockOverlayPebbles extends Block
         return null;
     }
 
-    @Override
-    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
-    {
-        return AABB.getTemporaryBB(x, y, z, x + 1, y + 0.0625f, z + 1);
-    }
-
     @Override
     public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
@@ -57,17 +52,6 @@ public class BlockOverlayPebbles extends Block
         }
     }
 
-    @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
-    {
-        minX = 0;
-        minY = 0;
-        minZ = 0;
-        maxX = 1;
-        maxY = 0.0625f;
-        maxZ = 1;
-    }
-
     @Override
     public boolean isCubeShaped()
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockPiePumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockPiePumpkin.java
new file mode 100644
index 000000000..4248f8671
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockPiePumpkin.java
@@ -0,0 +1,25 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.item.Items;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
+
+public class BlockPiePumpkin extends BlockEdible
+{
+
+    public BlockPiePumpkin(String key, String namespaceId, int id)
+    {
+        super(key, namespaceId, id, 4, 5, () -> Items.FOOD_PUMPKIN_PIE);
+    }
+
+    @Override
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
+    {
+        int l = world.getBlockMetadata(x, y, z);
+        float f = 0.0625F;
+        float xMin = l >= 2 ? 0.5f : f;
+        float zMin = l >= 3 ? 0.5f : f;
+        float f2 = 0.4375F;
+        return AABB.getTemporaryBB(xMin, 0.0F, zMin, 1.0F - f, f2, 1.0F - f);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockPortal.java b/game/core/src/main/java/net/minecraft/core/block/BlockPortal.java
similarity index 97%
rename from src/main/java/net/minecraft/core/block/BlockPortal.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockPortal.java
index 5b38bb027..1ff1eacf2 100644
--- a/src/main/java/net/minecraft/core/block/BlockPortal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockPortal.java
@@ -45,19 +45,19 @@ public class BlockPortal extends BlockTransparent implements IPainted
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
         int meta = world.getBlockMetadata(x, y, z);
         if((meta & 0x1) > 0)
         {
             float f1 = 0.125F;
             float f3 = 0.5F;
-            setBlockBounds(0.5F - f1, 0.0F, 0.5F - f3, 0.5F + f1, 1.0F, 0.5F + f3);
+            return AABB.getTemporaryBB(0.5F - f1, 0.0F, 0.5F - f3, 0.5F + f1, 1.0F, 0.5F + f3);
         } else
         {
             float f = 0.5F;
             float f2 = 0.125F;
-            setBlockBounds(0.5F - f, 0.0F, 0.5F - f2, 0.5F + f, 1.0F, 0.5F + f2);
+            return AABB.getTemporaryBB(0.5F - f, 0.0F, 0.5F - f2, 0.5F + f, 1.0F, 0.5F + f2);
         }
     }
 
@@ -318,12 +318,6 @@ public class BlockPortal extends BlockTransparent implements IPainted
         return null;
     }
 
-    @Override
-    public int getRenderLayer()
-    {
-        return 1;
-    }
-
     @Override
     public void onEntityCollidedWithBlock(World world, int x, int y, int z, Entity entity)
     {
diff --git a/src/main/java/net/minecraft/core/block/BlockPressurePlate.java b/game/core/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
similarity index 92%
rename from src/main/java/net/minecraft/core/block/BlockPressurePlate.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
index 8f1653361..0ca4062b0 100644
--- a/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockPressurePlate.java
@@ -140,7 +140,7 @@ public class BlockPressurePlate extends Block
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
         int meta = world.getBlockMetadata(x, y, z);
         boolean isPressed = isPressed(meta);
@@ -149,16 +149,16 @@ public class BlockPressurePlate extends Block
         if(isPressed)
         {
             if (isCeiling){
-                setBlockBounds(pixel, 1f - 0.03125F, pixel, 1.0F - pixel, 1f, 1.0F - pixel);
+                return AABB.getTemporaryBB(pixel, 1f - 0.03125F, pixel, 1.0F - pixel, 1f, 1.0F - pixel);
             } else {
-                setBlockBounds(pixel, 0.0F, pixel, 1.0F - pixel, 0.03125F, 1.0F - pixel);
+                return AABB.getTemporaryBB(pixel, 0.0F, pixel, 1.0F - pixel, 0.03125F, 1.0F - pixel);
             }
         } else
         {
             if (isCeiling){
-                setBlockBounds(pixel, 1f - 0.0625F, pixel, 1.0F - pixel, 1f, 1.0F - pixel);
+                return AABB.getTemporaryBB(pixel, 1f - 0.0625F, pixel, 1.0F - pixel, 1f, 1.0F - pixel);
             } else {
-                setBlockBounds(pixel, 0.0F, pixel, 1.0F - pixel, 0.0625F, 1.0F - pixel);
+                return AABB.getTemporaryBB(pixel, 0.0F, pixel, 1.0F - pixel, 0.0625F, 1.0F - pixel);
             }
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockRail.java b/game/core/src/main/java/net/minecraft/core/block/BlockRail.java
similarity index 97%
rename from src/main/java/net/minecraft/core/block/BlockRail.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockRail.java
index 7bf57d2ca..c6b17eb1b 100644
--- a/src/main/java/net/minecraft/core/block/BlockRail.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockRail.java
@@ -5,8 +5,6 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.HitResult;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.chunk.ChunkPosition;
@@ -53,18 +51,12 @@ public class BlockRail extends Block {
     }
 
     @Override
-    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end) {
-        setBlockBoundsBasedOnState(world, x, y, z);
-        return super.collisionRayTrace(world, x, y, z, start, end);
-    }
-
-    @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z) {
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z) {
         RailDirection direction = getRailDirection(world, x, y, z);
         if(direction.isSloped()) {
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.725F, 1.0F);
+            return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.725F, 1.0F);
         } else {
-            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
+            return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
         }
     }
 
@@ -101,7 +93,7 @@ public class BlockRail extends Block {
             return;
         }
 
-        Block block = Block.getBlock(blockId);
+        Block block = Blocks.getBlock(blockId);
 
         if(this == Blocks.RAIL_POWERED) {
             boolean gettingPower =
diff --git a/src/main/java/net/minecraft/core/block/BlockRope.java b/game/core/src/main/java/net/minecraft/core/block/BlockRope.java
similarity index 96%
rename from src/main/java/net/minecraft/core/block/BlockRope.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockRope.java
index 2eb026d0a..d81c2a43a 100644
--- a/src/main/java/net/minecraft/core/block/BlockRope.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockRope.java
@@ -41,7 +41,7 @@ public class BlockRope
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
+    public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
         boolean hasBlockNegX = world.getBlockId(x - 1, y, z) == this.id;
         boolean hasBlockPosX = world.getBlockId(x + 1, y, z) == this.id;
@@ -64,7 +64,7 @@ public class BlockRope
         if (hasBlockNegZ) minZ = 0;
         if (hasBlockPosZ) maxZ = 1;
 
-        setBlockBounds(minX, minY, minZ, maxX, maxY, maxZ);
+        return AABB.getTemporaryBB(minX, minY, minZ, maxX, maxY, maxZ);
     }
     
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockRotatable.java b/game/core/src/main/java/net/minecraft/core/block/BlockRotatable.java
similarity index 91%
rename from src/main/java/net/minecraft/core/block/BlockRotatable.java
rename to game/core/src/main/java/net/minecraft/core/block/BlockRotatable.java
index 1f5400741..b024201b6 100644
--- a/src/main/java/net/minecraft/core/block/BlockRotatable.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockRotatable.java
@@ -44,19 +44,19 @@ public abstract class BlockRotatable extends Block{
         int bW = world.getBlockId(x - 1, y, z);
         int bE = world.getBlockId(x + 1, y, z);
         Direction direction = Direction.NORTH;
-        if(Block.solid[bN] && !Block.solid[bS])
+        if(Blocks.solid[bN] && !Blocks.solid[bS])
         {
             direction = Direction.SOUTH;
         }
-        if(Block.solid[bS] && !Block.solid[bN])
+        if(Blocks.solid[bS] && !Blocks.solid[bN])
         {
             direction = Direction.NORTH;
         }
-        if(Block.solid[bW] && !Block.solid[bE])
+        if(Blocks.solid[bW] && !Blocks.solid[bE])
         {
             direction = Direction.EAST;
         }
-        if(Block.solid[bE] && !Block.solid[bW])
+        if(Blocks.solid[bE] && !Blocks.solid[bW])
         {
             direction = Direction.WEST;
         }
